<?xml version="1.0" encoding="UTF-8" ?> 

<!-- =============================================================== -->
<!--                                                                 -->
<!-- =====================================================           -->
<!-- copyright 2000 by voxeo corporation. (see LGPL.txt)             -->
<!--                                                                 -->
<!-- US Postal Codes database, Copyright (c) 2000 CD Light           -->
<!--                           All Rights Reserved.                  -->
<!-- =====================================================           -->
<!--                                                                 -->
<!-- v1.0 Coded in ColdFusion										 -->
<!-- v1.0 Coded by John Higgins and Stephen J. Lewis				 -->
<!--                                                                 -->
<!-- This application is prompts users over the phone for a 5 digit	 -->
<!-- zipcode, then accesses a database containing the US Postal Code -->
<!-- information for the year 2000 to find cities (and states) that  -->
<!-- match the zipcode.  It will read the results to the caller,     -->
<!-- then ask for another zipcode.  The same application has been    -->
<!-- written in ASP, PERL, and PHP (q.v.) as sample code on          -->
<!-- how to use CallXML and backend scripting languages.             -->
<!-- 																 -->
<!-- This file is associated with the following files:				 -->
<!--      zipcode.cfm           Reads the main menu and              -->
<!--                            gets the user inputed zipcode.   	 -->
<!--      US Postal Codes.mdb   The actual database file itself      -->
<!--																 -->
<!-- Several audio files are associated with this application:		 -->
<!--           MainMenu.wav											 -->
<!--           Results.wav											 -->
<!--           MultipleResults.wav								     -->
<!--           NotFound.wav											 -->
<!--           YouHaveTakenTooLong.wav								 -->
<!--																 -->
<!-- All audio files are PCM format, 8-bit, mono, unsigned.			 -->
<!--																 -->
<!-- =============================================================== -->

<callxml>    
  <block>
	<!-- ============================================================== -->
	<!-- This is where we extract the city/state info from our database -->
	<!-- ============================================================== -->
	
	<cfquery name="ZipcodeInfo" datasource="USPostalCodes">
		select * from PostalCodes where Zipcode='#zipcode#' order by City desc
	</cfquery>
	
	<cfset Loopy       = "0">
	<cfset CallXMLText = "">
	
	<!-- ================================= -->
	<!-- Loop through the entire recordset -->
	<!-- ================================= -->
	
	<cfoutput query="ZipcodeInfo">
      <cfset Loopy = #IncrementValue(Loopy)#>
		
      <!-- =================================================    -->
      <!-- We have to check for certain states because the      -->
	  <!-- callxml TTS engine will not pronounce them correctly -->
      <!-- =================================================    -->

      <cfset Temp="#State#">
      
	  <cfswitch expression="#State#">
		<cfcase value="AL">
		  <cfset Temp="Alabama">
		</cfcase>
		<cfcase value="CT">
		  <cfset Temp="Connecticut">
		</cfcase>
		<cfcase value="CO">
		  <cfset Temp="Colorado">
		</cfcase>
		<cfcase value="DE">
		  <cfset Temp="Delaware">
		</cfcase>
		<cfcase value="HI">
		  <cfset Temp="Hawaii">
		</cfcase>
		<cfcase value="ID">
		  <cfset Temp="Idaho">
		</cfcase>
		<cfcase value="IN">
		  <cfset Temp="Indiana">
		</cfcase>
		<cfcase value="LA">
		  <cfset Temp="Louisiana">
		</cfcase>
		<cfcase value="MA">
		  <cfset Temp="Massachusetts">
		</cfcase>
		<cfcase value="MD">
		  <cfset Temp="Maryland">
		</cfcase>
		<cfcase value="ME">
		  <cfset Temp="Maine">
		</cfcase>
		<cfcase value="MI">
		  <cfset Temp="Michigan">
		</cfcase>
		<cfcase value="MO">
		  <cfset Temp="Missouri">
		</cfcase>
		<cfcase value="MS">
		  <cfset Temp="Mississippi">
		</cfcase>
		<cfcase value="MT">
		  <cfset Temp="Montana">
		</cfcase>
		<cfcase value="NE">
		  <cfset Temp="Nebraska">
		</cfcase>
		<cfcase value="OH">
		  <cfset Temp="Ohio">
		</cfcase>
		<cfcase value="OK">
		  <cfset Temp="Oklahoma">
		</cfcase>
		<cfcase value="OR">
		  <cfset Temp="Oregon">
		</cfcase>
		<cfcase value="PA">
		  <cfset Temp="Pennsylvania">
		</cfcase>
		<cfcase value="WA">
		  <cfset Temp="Washington">
		</cfcase>
		<cfcase value="WY">
		  <cfset Temp="Wyoming">
		</cfcase>
	  </cfswitch>

	  <cfset CallXMLText = "#CallXMLText#<text>#City#,#Temp#</text>">		
    </cfoutput>
	  
	<cfoutput>
	  <!-- ========================================== -->		
	  <!-- We need to play the appropriate prompt for -->
	  <!-- no matches, 1 match, or multiple matches.  -->
	  <!-- ========================================== -->		
	
	  <cfif Loopy is "0">
	    <playaudio format="audio/wav" value="NotFound.wav" />    
	  <cfelseif Loopy is "1">	
	    <playaudio format="audio/wav" value="Results.wav" />
	  <cfelse>	
	    <playaudio format="audio/wav" value="MultipleResults.wav" />
	  </cfif>	
	  
	  #CallXMLText#
	</cfoutput>
	  
    <!-- ===================================================== -->
    <!-- We want to pause for 2 seconds, clear out the zipcode -->
    <!-- variable, and then return to the main menu.           -->
    <!-- ===================================================== -->
	
    <wait value="2s"/>
    <goto value="$myURL;zipcode.cfm" submit="*" method="get" />
 </block>
</callxml>