<%@ LANGUAGE = VBScript %>
  
<%

' ---------------------------------------------------------------
'
' -----------------------------------------------------
' copyright 2000 by voxeo corporation. (see LGPL.txt)
'
' US Postal Codes database, Copyright (c) 2000 CD Light
'                           All Rights Reserved.
' -----------------------------------------------------
'
' v1.0 Coded in ASP
' v1.0 Coded by Stephen J. Lewis
'
' This application is prompts users over the phone for a 5 digit
' zipcode, then accesses a database containing the US Postal Code
' information for the year 2000 to find cities (and states) that
' match the zipcode.  It will read the results to the caller,
' then ask for another zipcode.  The same application has been
' written in PHP, JSP, PERL, Cold Fusion, and as a Java Servlet (q.v.)
' as sample code on how to use CallXML and backend scripting languages.  
'
' This file is associated with the following files:				 
'     US Postal Codes.mdb   <---- The actual database file itself      
'
' Several audio files are associated with this application:
'           MainMenu.wav
'           Results.wav
'           MutlipleResults.wav
'           NotFound.wav
'           YouHaveTakenTooLong.wav
'
' All audio files are PCM format, 8-bit, mono, unsigned.
'
'----------------------------------------------------------------
  
'-----------------------------------------------------------------------------------------

Sub CloseDatabase
  TempConnection.close
  set TempConnection=nothing
End Sub

'----------------------------------------------------------------------------------------

Sub OpenDatabase
  set TempConnection = Server.CreateObject("ADODB.Connection")
  TempConnection.Open "USPostalCodes"
End Sub

'----------------------------------------------------------------------------------------

Sub Initialize
  response.write "<?xml version=""1.0"" encoding=""UTF-8""?>" 
  response.write "<callxml>"
  
  '------------------------------------------------------------------------
  ' This annoying little variable is simply incremented and passed along to
  ' avoid the AGS's caching.  This helps to ensure that a different URL
  ' query string will be passed.
  '------------------------------------------------------------------------

  if (request("cachekiller") = "") then
    response.write "<assign var=""cachekiller"" value=""1""/>"
  else
	response.write "<assign var=""cachekiller"" value=""" & (request("cachekiller") + 1) & """/>"
  end if  ' else statement
  
End Sub  ' initialize subroutine
  
'-------------------------------------------------------------------------------------

Sub Closure

  response.write "</callxml>"

End Sub ' closure subroutine

'----------------------------------------------------------------------------------------

Sub ZipCodeMenu
  '-----------------------------------------------------------------------------
  ' Initialize our databasing routines and select out all matches to the zipcode
  '-----------------------------------------------------------------------------
  
  Dim TempDatabase
  call OpenDatabase
  
  TempSQL = "select * from PostalCodes where Zipcode = '" & request("zipcode") & "'"
  
  set TempDatabase = TempConnection.execute(TempSQL)

  response.write "<block>"  
  
  Loopy       = 0
  CallXMLText = ""
  
  while ( NOT TempDatabase.EOF )
    Loopy = Loopy + 1
    City  = TempDatabase("City")
    State = TempDatabase("State")  
	
    '-----------------------------------------------------
    ' We have to check for certain states because the
	' callxml TTS engine will not pronounce them correctly
    '-----------------------------------------------------

	Select Case State
	  Case "AL" State = "Alabama"
	  Case "CT" State = "Connecticut"
	  Case "CO" State = "Colorado"
	  Case "DE" State = "Delaware"
	  Case "HI" State = "Hawaii"
	  Case "ID" State = "Idaho"
	  Case "IN" State = "Indiana"
	  Case "LA" State = "Louisiana"
	  Case "MA" State = "Massachusetts"
	  Case "MD" State = "Maryland"
	  Case "ME" State = "Maine"
	  Case "MI" State = "Michigan"
	  Case "MO" State = "Missouri"
	  Case "MS" State = "Mississippi"
	  Case "MT" State = "Montana"
	  Case "NE" State = "Nebraska"
	  Case "OH" State = "Ohio"
	  Case "OK" State = "Oklahoma"
	  Case "OR" State = "Oregon"
	  Case "PA" State = "Pennsylvania"
	  Case "WA" State = "Washington"
	  Case "WY" State = "Wyoming"
    End Select
	
    CallXMLText = CallXMLText & "<text>" & City & "," & State & "</text>"
    TempDatabase.MoveNext
  wend  ' while loop
  
  '-------------------------------------------
  ' We need to play the appropriate prompt for 
  ' no matches, 1 match, or multiple matches.
  '-------------------------------------------  
  
  if (Loopy = 0) then
    response.write "<playaudio format=""audio/wav"" value=""NotFound.wav"" />"    
  elseif (Loopy = 1) then
    response.write "<playaudio format=""audio/wav"" value=""Results.wav"" />"
  else
    response.write "<playaudio format=""audio/wav"" value=""MultipleResults.wav"" />"  
  end if  ' else statement
  
  response.write CallXMLText
  
  '------------------------------------------------------
  ' We want to pause for 2 seconds, clear out the zipcode 
  ' variable, and then return to the main menu.
  '------------------------------------------------------  
  
  response.write "<wait value=""2s""/>"
  response.write "<clear var=""ZipCode""/>"
  response.write "<goto value=""" & PathString & "zipcode.asp"" submit=""*"" method=""get"" />" 
  response.write "</block>"
  
  call CloseDatabase
End Sub  ' suboutine ZipCodeMenu

'-------------------------------------------------------------------------------------

Sub MainMenu
  response.write "<inputdigits label=""input_selection"" " & _
                    "repeat=""3"" " & _
				    "var=""ZipCode"" " & _
				    "format=""audio/wav"" " & _ 
				    "value=""MainMenu.wav"" " & _ 
				    "cleardigits=""TRUE"" " & _
				    "includetermdigit=""FALSE"" " & _
				    "maxdigits=""5"" " & _
				    "maxtime=""15s"" " & _
				    "maxsilence=""5s"" >" 

  response.write "<onmaxdigits>"
  response.write "<goto value=""" & PathString & "zipcode.asp"" submit=""*"" method=""get"" />" 
  response.write "</onmaxdigits>"
  
  response.write "<onmaxtime>"
  response.write "<playaudio format=""audio/wav"" value=""YouHaveTakenTooLong.wav"" />"  
  response.write "<hangup/>"
  response.write "</onmaxtime>"
  
  response.write "<onmaxsilence>"
  response.write "<playaudio format=""audio/wav"" value=""YouHaveTakenTooLong.wav"" />"  
  response.write "<hangup/>"
  response.write "</onmaxsilence>"
  
  response.write "</inputdigits>"
  
  '-----------------------------------
  ' One last message in case the block 
  ' loops through before maxsilence or
  ' maxtime has been reached.
  '-----------------------------------
  
  response.write "<playaudio format=""audio/wav"" value=""YouHaveTakenTooLong.wav"" />"    
End Sub  ' subroutine MainMenu

'-------------------------------------------------------------------------------------
' NOTE THAT THIS NEXT LINE WILL NEED TO BE EDITED TO POINT TO YOUR OWN WEBSERVER
'-------------------------------------------------------------------------------------

PathString = "http://MyServer.com/MyDirectory/"




Dim City, State, TempConnection

call Initialize

'---------------------------------------------------
' The Querystring variable zipcode determine whether 
' we need to go to the main menu, or if a caller has
' just entered in a ZipCode.
'---------------------------------------------------

if (request("zipcode") <> "") then 
  call ZipCodeMenu
else
  call MainMenu
end if

call Closure

%>